763055e61365ff94c1a3941f908b4a90c454eed6
[deliverable/binutils-gdb.git] / configure.in
1 #! /bin/bash
2 ##############################################################################
3
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
8
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
13
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
16
17 # Copyright (C) 1992, 93, 94, 95, 1996 Free Software Foundation, Inc.
18 #
19 # This file is free software; you can redistribute it and/or modify it
20 # under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
23 #
24 # This program is distributed in the hope that it will be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27 # General Public License for more details.
28 #
29 # You should have received a copy of the GNU General Public License
30 # along with this program; if not, write to the Free Software
31 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
32
33 ##############################################################################
34
35 ### To add a new directory to the tree, first choose whether it is a target
36 ### or a host dependent tool. Then put it into the appropriate list
37 ### (library or tools, host or target), doing a dependency sort. For
38 ### example, gdb requires that byacc (or bison) be built first, so it is in
39 ### the ${host_tools} list after byacc and bison.
40
41
42 # these libraries are used by various programs built for the host environment
43 #
44 host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
45
46 if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
48 fi
49
50 # these tools are built for the host environment
51 #
52 host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch prms send-pr gprof gdbtest tgas etc expect dejagnu sim bash m4 autoconf ispell grep diff rcs cvs fileutils shellutils time textutils wdiff find emacs emacs19 uudecode hello tar gzip indent recode release sed utils guile perl apache inet gawk"
53
54
55 # these libraries are built for the target environment, and are built after
56 # the host libraries and the host tools (which may be a cross compiler)
57 #
58 target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
59
60
61 # these tools are built using the target libs, and are intended to run only
62 # in the target environment
63 #
64 # note: any program that *uses* libraries that are in the "target_libs"
65 # list belongs in this list. those programs are also very likely
66 # candidates for the "native_only" list which follows
67 #
68 target_tools="target-examples target-groff"
69
70 ################################################################################
71
72 ## These two lists are of directories that are to be removed from the
73 ## ${configdirs} list for either cross-compilations or for native-
74 ## compilations. For example, it doesn't make that much sense to
75 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
76 ## a native environment.
77
78 # directories to be built in the native environment only
79 #
80 # This must be a single line because of the way it is searched by grep in
81 # the code below.
82 native_only="autoconf cvs emacs emacs19 fileutils find gawk grep gzip hello indent ispell m4 rcs recode sed shellutils tar textutils gash uudecode wdiff gprof target-groff guile perl apache inet time bash prms"
83
84 # directories to be built in a cross environment only
85 #
86 cross_only="target-libiberty target-libgloss target-newlib"
87
88 ## All tools belong in one of the four categories, and are assigned above
89 ## We assign ${configdirs} this way to remove all embedded newlines. This
90 ## is important because configure will choke if they ever get through.
91 ## ${configdirs} is directories we build using the host tools.
92 ## ${target_configdirs} is directories we build using the target tools.
93 #
94 configdirs=`echo ${host_libs} ${host_tools}`
95 target_configdirs=`echo ${target_libs} ${target_tools}`
96
97 ################################################################################
98
99 srctrigger=move-if-change
100 srcname="gnu development package"
101
102 # This gets set non-empty for some net releases of packages.
103 appdirs=""
104
105 # per-host:
106
107 # Work in distributions that contain no compiler tools, like Autoconf.
108 if [ -d ${srcdir}/config ]; then
109 case "${host}" in
110 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
111 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
112 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
113 m68k-*-linux*) host_makefile_frag=config/mh-linux ;;
114 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
115 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
116 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
117 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
118 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
119 mips*-sgi-irix6*) host_makefile_frag=config/mh-irix6 ;;
120 mips*-sgi-irix5*) host_makefile_frag=config/mh-irix5 ;;
121 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
122 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
123 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
124 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
125 i[3456]86-*-dgux*) host_makefile_frag=config/mh-dgux386 ;;
126 i[3456]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
127 i[3456]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
128 i[3456]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
129 i[3456]86-*-sco*) host_makefile_frag=config/mh-sco ;;
130 i[3456]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
131 i[3456]86-*-linux*) host_makefile_frag=config/mh-linux ;;
132 i[3456]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
133 i[3456]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
134 i[3456]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
135 *-cygwin32*) host_makefile_frag=config/mh-cygwin32 ;;
136 *-windows*) host_makefile_frag=config/mh-windows ;;
137 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
138 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
139 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
140 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
141 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
142 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
143 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
144 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
145 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
146 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
147 esac
148 fi
149
150 # If we aren't going to be using gcc, see if we can extract a definition
151 # of CC from the fragment.
152 if [ -z "${CC}" -a "${build}" = "${host}" ]; then
153 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
154 found=
155 for dir in $PATH; do
156 test -z "$dir" && dir=.
157 if test -f $dir/gcc; then
158 found=yes
159 break
160 fi
161 done
162 IFS="$save_ifs"
163 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
164 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
165 if [ -n "${xx}" ] ; then
166 CC=$xx
167 fi
168 fi
169 fi
170
171 # We default to --with-shared on platforms where -fpic is meaningless.
172 # Well, we don't yet, but we will.
173 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
174 case "${target}" in
175 alpha-dec-osf*) enable_shared=yes ;;
176 alpha-*-linux*) enable_shared=yes ;;
177 mips-sgi-irix5*) enable_shared=yes ;;
178 *) enable_shared=no ;;
179 esac
180 fi
181
182 case "${enable_shared}" in
183 yes) shared=yes ;;
184 no) shared=no ;;
185 "") shared=no ;;
186 *) shared=yes ;;
187 esac
188
189 if [ x${shared} = xyes ]; then
190 waugh=
191 case "${host}" in
192 hppa*) waugh=config/mh-papic ;;
193 i[3456]86-*) waugh=config/mh-x86pic ;;
194 sparc64-*) waugh=config/mh-sparcpic ;;
195 *) waugh=config/mh-${host_cpu}pic ;;
196 esac
197 if [ -f ${srcdir}/${waugh} ]; then
198 if [ -n "${host_makefile_frag}" ] ; then
199 cat ${srcdir}/${host_makefile_frag} > mh-frag
200 cat ${srcdir}/${waugh} >> mh-frag
201 host_makefile_frag=mh-frag
202 else
203 host_makefile_frag=${waugh}
204 fi
205 fi
206 fi
207
208 # per-target:
209
210 case "${target}" in
211 v810*) target_makefile_frag=config/mt-v810 ;;
212 i[3456]86-*-netware*) target_makefile_frag=config/mt-netware ;;
213 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
214 powerpc*-*-eabi* | \
215 powerpc*-*-elf* | \
216 powerpc*-*-linux* | \
217 powerpc*-*-rtem* | \
218 powerpc*-*-sysv* | \
219 powerpc*-*-solaris*) target_makefile_frag=config/mt-ppc ;;
220 esac
221
222 skipdirs=
223 gasdir=gas
224 use_gnu_ld=
225 use_gnu_as=
226
227 # some tools are so dependent upon X11 that if we're not building with X,
228 # it's not even worth trying to configure, much less build, that tool.
229
230 case ${with_x} in
231 yes | "") # the default value for this tree is that X11 is available
232 ;;
233 no)
234 skipdirs="${skipdirs} tk gash"
235 ;;
236 *)
237 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
238 ;;
239 esac
240
241 # Some tools are only suitable for building in a "native" situation.
242 # Those are added when we have a host==target configuration. For cross
243 # toolchains, we add some directories that should only be useful in a
244 # cross-compiler.
245
246 is_cross_compiler=
247
248 if [ x"${host}" = x"${target}" ] ; then
249 # when doing a native toolchain, don't build the targets
250 # that are in the 'cross only' list
251 skipdirs="${skipdirs} ${cross_only}"
252 is_cross_compiler=no
253 target_subdir=.
254 else
255 # similarly, don't build the targets in the 'native only'
256 # list when building a cross compiler
257 skipdirs="${skipdirs} ${native_only}"
258 is_cross_compiler=yes
259 target_subdir=${target_alias}
260 if [ ! -d ${target_subdir} ] ; then
261 if mkdir ${target_subdir} ; then true
262 else
263 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
264 exit 1
265 fi
266 fi
267 fi
268
269 copy_dirs=
270
271 # Handle --with-headers=XXX. The contents of the named directory are
272 # copied to $(tooldir)/sys-include.
273 if [ x"${with_headers}" != x ]; then
274 if [ x${is_cross_compiler} = xno ]; then
275 echo 1>&2 '***' --with-headers is only supported when cross compiling
276 exit 1
277 fi
278 case "${exec_prefixoption}" in
279 "") x=${prefix} ;;
280 *) x=${exec_prefix} ;;
281 esac
282 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
283 fi
284
285 # Handle --with-libs=XXX. Multiple directories are permitted. The
286 # contents are copied to $(tooldir)/lib.
287 if [ x"${with_libs}" != x ]; then
288 if [ x${is_cross_compiler} = xno ]; then
289 echo 1>&2 '***' --with-libs is only supported when cross compiling
290 exit 1
291 fi
292 # Copy the libraries in reverse order, so that files in the first named
293 # library override files in subsequent libraries.
294 case "${exec_prefixoption}" in
295 "") x=${prefix} ;;
296 *) x=${exec_prefix} ;;
297 esac
298 for l in ${with_libs}; do
299 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
300 done
301 fi
302
303 # If both --with-headers and --with-libs are specified, default to
304 # --without-newlib.
305 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
306 if [ x"${with_newlib}" = x ]; then
307 with_newlib=no
308 fi
309 fi
310
311 # Recognize --with-newlib/--without-newlib.
312 if [ x${with_newlib} = xno ]; then
313 skipdirs="${skipdirs} target-newlib"
314 elif [ x${with_newlib} = xyes ]; then
315 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
316 fi
317
318 # Default to using --with-stabs for certain targets.
319 if [ x${with_stabs} = x ]; then
320 case "${target}" in
321 mips*-*-* | alpha*-*-osf* | i[3456]86*-*-sysv4* | i[3456]86*-*-unixware*)
322 with_stabs=yes;
323 withoptions="${withoptions} --with-stabs"
324 ;;
325 esac
326 fi
327
328 # Handle ${copy_dirs}
329 set fnord ${copy_dirs}
330 shift
331 while [ $# != 0 ]; do
332 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
333 :
334 else
335 echo Copying $1 to $2
336
337 # Use the install script to create the directory and all required
338 # parent directories.
339 if [ -d $2 ]; then
340 :
341 else
342 echo >config.temp
343 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
344 fi
345
346 # Copy the directory, assuming we have tar.
347 # FIXME: Should we use B in the second tar? Not all systems support it.
348 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
349
350 # It is the responsibility of the user to correctly adjust all
351 # symlinks. If somebody can figure out how to handle them correctly
352 # here, feel free to add the code.
353
354 echo $1 > $2/COPIED
355 fi
356 shift; shift
357 done
358
359 # Configure extra directories which are host specific
360
361 case "${host}" in
362 i[3456]86-*-go32*)
363 configdirs="$configdirs dosrel" ;;
364 *-cygwin32*)
365 configdirs="$configdirs dosrel" ;;
366 esac
367
368 # Remove more programs from consideration, based on the host or
369 # target this usually means that a port of the program doesn't
370 # exist yet.
371
372 noconfigdirs=""
373
374 case "${host}" in
375 i[3456]86-*-vsta)
376 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
377 ;;
378 i[3456]86-*-go32)
379 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
380 ;;
381 *-*-cygwin32 | *-*-windows*)
382 noconfigdirs="tk tcl expect dejagnu cvs autoconf bison send-pr gprof rcs guile perl texinfo apache inet"
383 ;;
384 ppc*-*-pe)
385 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
386 ;;
387 esac
388
389
390 case "${target}" in
391 *-*-netware)
392 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
393 ;;
394 *-*-vxworks*)
395 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
396 ;;
397 alpha-dec-osf*)
398 # ld works, but does not support shared libraries. emacs doesn't
399 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
400 # gas doesn't generate exception information.
401 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib target-libgloss"
402 ;;
403 alpha*-*-*vms*)
404 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
405 ;;
406 alpha*-*-*)
407 # newlib is not 64 bit ready
408 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
409 ;;
410 # start-sanitize-arc
411 arc-*-*)
412 noconfigdirs="$noconfigdirs target-libgloss"
413 ;;
414 # end-sanitize-arc
415 arm-*-pe*)
416 noconfigdirs="$noconfigdirs target-libgloss"
417 ;;
418 arm-*-coff*)
419 noconfigdirs="$noconfigdirs target-libgloss"
420 ;;
421 arm-*-riscix*)
422 noconfigdirs="$noconfigdirs ld target-libgloss"
423 ;;
424 # start-sanitize-d10v
425 d10v-*-*)
426 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-libgloss"
427 ;;
428 # end-sanitize-d10v
429 h8300*-*-* | \
430 h8500-*-*)
431 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
432 ;;
433 hppa*-*-*elf* | \
434 hppa*-*-lites*)
435 # Do configure ld/binutils/gas for this case.
436 ;;
437 hppa*-*-*)
438 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
439 # cc is gcc, and on any system a user should be able to link cc to
440 # whatever they want. FIXME, emacs emacs19).
441 case "${CC}" in
442 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
443 *) ;;
444 esac
445 noconfigdirs="$noconfigdirs ld shellutils"
446 ;;
447 i[3456]86-*-go32)
448 # but don't build gdb
449 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
450 ;;
451 *-*-cygwin32)
452 target_configdirs="$target_configdirs target-winsup"
453 noconfigdirs="$noconfigdirs tcl tk expect target-libgloss"
454 # always build newlib.
455 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
456
457 # Can't build gdb for cygwin32 if not native.
458 case "${host}" in
459 *-*-cygwin32) ;; # keep gdb
460 *) noconfigdirs="$noconfigdirs gdb"
461 esac
462 ;;
463 i[3456]86-*-pe)
464 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
465 ;;
466 i[3456]86-*-sco3.2v5*)
467 # The linker does not yet know about weak symbols in COFF,
468 # and is not configured to handle mixed ELF and COFF.
469 noconfigdirs="$noconfigdirs gprof ld target-libgloss"
470 ;;
471 i[3456]86-*-sco*)
472 noconfigdirs="$noconfigdirs gprof target-libgloss"
473 ;;
474 i[3456]86-*-solaris2*)
475 # The linker does static linking correctly, but the Solaris C library
476 # has bugs such that some important functions won't work when statically
477 # linked. (See man pages for getpwuid, for example.)
478 noconfigdirs="$noconfigdirs ld target-libgloss"
479 ;;
480 i[3456]86-*-sysv4*)
481 # The SYSV4 C compiler doesn't handle Emacs correctly
482 case "${CC}" in
483 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
484 *) ;;
485 esac
486 # but that's okay since emacs doesn't work anyway
487 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
488 ;;
489 # start-sanitize-m32r
490 m32r-*-*)
491 noconfigdirs="$noconfigdirs target-libgloss libio libstdc++ libg++ gdb"
492 ;;
493 # end-sanitize-m32r
494 mn10200-*-*)
495 noconfigdirs="$noconfigdirs ld gcc gdb target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
496 ;;
497 mn10300-*-*)
498 noconfigdirs="$noconfigdirs ld gcc gdb target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
499 ;;
500 powerpc-*-aix*)
501 # copied from rs6000-*-* entry
502 noconfigdirs="$noconfigdirs gprof cvs target-libgloss"
503 # This is needed until gcc and ld are fixed to work together.
504 use_gnu_ld=no
505 ;;
506 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
507 target_configdirs="$target_configdirs target-winsup"
508 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss"
509 # always build newlib.
510 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
511 ;;
512 # This is temporary until we can link against shared libraries
513 powerpcle-*-solaris*)
514 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect"
515 ;;
516 rs6000-*-lynxos*)
517 # The CVS server code doesn't work on the RS/6000
518 # Newlib makes problems for libg++ in crosses.
519 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
520 ;;
521 rs6000-*-aix*)
522 noconfigdirs="$noconfigdirs gprof"
523 # This is needed until gcc and ld are fixed to work together.
524 use_gnu_ld=no
525 ;;
526 rs6000-*-*)
527 noconfigdirs="$noconfigdirs gprof"
528 ;;
529 m68k-apollo-*)
530 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
531 ;;
532 mips*-*-irix5*)
533 # The GNU linker does not support shared libraries.
534 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
535 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
536 ;;
537 mips*-*-irix6*)
538 # The GNU linker does not support shared libraries.
539 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
540 # BFD does not have Irix 6 support yet.
541 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes gdb readline mmalloc sim gprof emacs target-libgloss"
542 ;;
543 mips*-dec-bsd*)
544 noconfigdirs="$noconfigdirs gprof target-libgloss"
545 ;;
546 mips*-*-bsd*)
547 noconfigdirs="$noconfigdirs gprof target-libgloss"
548 ;;
549 mips*-*-*)
550 noconfigdirs="$noconfigdirs gprof"
551 ;;
552 romp-*-*)
553 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
554 ;;
555 sh-*-*)
556 case "${host}" in
557 i[3456]86-*-vsta) ;; # don't add gprof back in
558 i[3456]86-*-go32) ;; # don't add gprof back in
559 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
560 esac
561 noconfigdirs="$noconfigdirs target-libgloss"
562 ;;
563 sparc-*-sunos4*)
564 if [ x${is_cross_compiler} != xno ] ; then
565 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
566 else
567 use_gnu_ld=no
568 fi
569 ;;
570 v810-*-*)
571 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
572 ;;
573 # start-sanitize-v850
574 v850-*-*)
575 noconfigdirs="$noconfigdirs target-libgloss"
576 ;;
577 # end-sanitize-v850
578 vax-*-vms)
579 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
580 ;;
581 vax-*-*)
582 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
583 ;;
584 *-*-lynxos*)
585 # Newlib makes problems for libg++ in crosses.
586 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
587 ;;
588 *-*-macos* | \
589 *-*-mpw*)
590 # Macs want a resource compiler.
591 configdirs="$configdirs grez"
592 ;;
593 esac
594
595 # targets that need a second pass
596 case "${target}" in
597 *-gm-magic*)
598 noconfigdirs="$noconfigdirs target-libgloss"
599 ;;
600 esac
601
602 # If we aren't building newlib, then don't build libgloss, since libgloss
603 # depends upon some newlib header files.
604 case "${noconfigdirs}" in
605 *target-libgloss*) ;;
606 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
607 esac
608
609 # If we are building a Canadian Cross, discard tools that can not be built
610 # using a cross compiler. FIXME: These tools should be fixed.
611 if [ "${build}" != "${host}" ]; then
612 noconfigdirs="$noconfigdirs tcl tk expect dejagnu"
613 fi
614
615 # Make sure we don't let GNU ld be added if we didn't want it.
616 if [ x$with_gnu_ld = xno ]; then
617 use_gnu_ld=no
618 noconfigdirs="$noconfigdirs ld"
619 fi
620
621 # Make sure we don't let GNU as be added if we didn't want it.
622 if [ x$with_gnu_as = xno ]; then
623 use_gnu_as=no
624 noconfigdirs="$noconfigdirs gas"
625 fi
626
627 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
628 # $target_configdirs.
629 # If we have the source for $noconfigdirs entries, add them to $notsupp.
630
631 notsupp=""
632 for dir in . $skipdirs $noconfigdirs ; do
633 dirname=`echo $dir | sed -e s/target-//g`
634 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
635 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
636 if [ -r $srcdir/$dirname/configure ] \
637 || [ -r $srcdir/$dirname/configure.in ]; then
638 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
639 true
640 else
641 notsupp="$notsupp $dir"
642 fi
643 fi
644 fi
645 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
646 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
647 if [ -r $srcdir/$dirname/configure ] \
648 || [ -r $srcdir/$dirname/configure.in ]; then
649 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
650 true
651 else
652 notsupp="$notsupp $dir"
653 fi
654 fi
655 fi
656 done
657
658 # Sometimes the tools are distributed with libiberty but with no other
659 # libraries. In that case, we don't want to build target-libiberty.
660 if [ -n "${target_configdirs}" ]; then
661 others=
662 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
663 if [ "$i" != "libiberty" ]; then
664 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
665 others=yes;
666 break;
667 fi
668 fi
669 done
670 if [ -z "${others}" ]; then
671 target_configdirs=
672 fi
673 fi
674
675 # Deconfigure all subdirectories, in case we are changing the
676 # configuration from one where a subdirectory is supported to one where it
677 # is not.
678 if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
679 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
680 rm -f $i/Makefile
681 done
682 fi
683 if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
684 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
685 rm -f ${target_subdir}/$i/Makefile
686 done
687 fi
688
689 # Produce a warning message for the subdirs we can't configure.
690 # This isn't especially interesting in the Cygnus tree, but in the individual
691 # FSF releases, it's important to let people know when their machine isn't
692 # supported by the one or two programs in a package.
693
694 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
695 # If $appdirs is non-empty, at least one of those directories must still
696 # be configured, or we error out. (E.g., if the gas release supports a
697 # specified target in some subdirs but not the gas subdir, we shouldn't
698 # pretend that all is well.)
699 if [ -n "$appdirs" ]; then
700 for dir in $appdirs ; do
701 if [ -r $dir/Makefile.in ]; then
702 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
703 appdirs=""
704 break
705 fi
706 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
707 appdirs=""
708 break
709 fi
710 fi
711 done
712 if [ -n "$appdirs" ]; then
713 echo "*** This configuration is not supported by this package." 1>&2
714 exit 1
715 fi
716 fi
717 # Okay, some application will build, or we don't care to check. Still
718 # notify of subdirs not getting built.
719 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
720 echo " ${notsupp}" 1>&2
721 echo " (Any other directories should still work fine.)" 1>&2
722 fi
723
724 # Set with_gnu_as and with_gnu_ld as appropriate.
725 #
726 # This is done by determining whether or not the appropriate directory
727 # is available, and by checking whether or not specific configurations
728 # have requested that this magic not happen.
729 #
730 # The command line options always override the explicit settings in
731 # configure.in, and the settings in configure.in override this magic.
732 #
733 # If the default for a toolchain is to use GNU as and ld, and you don't
734 # want to do that, then you should use the --without-gnu-as and
735 # --without-gnu-ld options for the configure script.
736
737 if [ x${use_gnu_as} = x ] ; then
738 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
739 with_gnu_as=yes
740 withoptions="$withoptions --with-gnu-as"
741 fi
742 fi
743
744 if [ x${use_gnu_ld} = x ] ; then
745 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
746 with_gnu_ld=yes
747 withoptions="$withoptions --with-gnu-ld"
748 fi
749 fi
750
751 # If using newlib, add --with-newlib to the withoptions so that gcc/configure
752 # can detect this case.
753
754 if [ x${with_newlib} != xno ] && echo " ${target_configdirs} " | grep " target-newlib " > /dev/null 2>&1 && [ -d ${srcdir}/newlib ] ; then
755 with_newlib=yes
756 withoptions="$withoptions --with-newlib"
757 fi
758
759 if [ x${shared} = xyes ]; then
760 case "${target}" in
761 hppa*) target_makefile_frag=config/mt-papic ;;
762 i[3456]86-*) target_makefile_frag=config/mt-x86pic ;;
763 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
764 esac
765 fi
766
767 # post-target:
768
769 # Make sure that the compiler is able to generate an executable. If it
770 # can't, we are probably in trouble. We don't care whether we can run the
771 # executable--we might be using a cross compiler--we only care whether it
772 # can be created. At this point the main configure script has set CC.
773 echo "int main () { return 0; }" > conftest.c
774 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
775 if [ $? = 0 ] && [ -s conftest ]; then
776 :
777 else
778 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
779 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
780 rm -f conftest*
781 exit 1
782 fi
783 rm -f conftest*
784
785 # The Solaris /usr/ucb/cc compiler does not appear to work.
786 case "${host}" in
787 sparc-sun-solaris2*)
788 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
789 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
790 could_use=
791 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
792 if [ -d /opt/cygnus/bin ] ; then
793 if [ "$could_use" = "" ] ; then
794 could_use="/opt/cygnus/bin"
795 else
796 could_use="$could_use or /opt/cygnus/bin"
797 fi
798 fi
799 if [ "$could_use" = "" ] ; then
800 echo "Warning: compilation may fail because you're using"
801 echo "/usr/ucb/cc. You should change your PATH or CC "
802 echo "variable and rerun configure."
803 else
804 echo "Warning: compilation may fail because you're using"
805 echo "/usr/ucb/cc, when you should use the C compiler from"
806 echo "$could_use. You should change your"
807 echo "PATH or CC variable and rerun configure."
808 fi
809 fi
810 ;;
811 esac
812
813 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
814 # binutils tools will find libbfd.so.
815 if [ "${shared}" = "yes" ]; then
816 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
817 Makefile > Makefile.tem
818 rm -f Makefile
819 mv -f Makefile.tem Makefile
820
821 case "${host}" in
822 *-*-hpux*)
823 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
824 Makefile > Makefile.tem
825 rm -f Makefile
826 mv -f Makefile.tem Makefile
827 ;;
828 esac
829 fi
830
831 # Record target_configdirs and the configure arguments in Makefile.
832 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
833 targargs=`echo "${arguments}" | \
834 sed -e 's/--norecursion//' \
835 -e 's/--cache[a-z-]*=[^ ]*//' \
836 -e 's/--ho[a-z-]*=[^ ]*//' \
837 -e 's/--ta[a-z-]*=[^ ]*//'`
838
839 # Passing a --with-cross-host argument lets the target libraries know
840 # whether they are being built with a cross-compiler or being built
841 # native. However, it would be better to use other mechanisms to make the
842 # sorts of decisions they want to make on this basis. Please consider
843 # this option to be deprecated. FIXME.
844 if [ x${is_cross_compiler} = xyes ]; then
845 targargs="--with-cross-host=${host_alias} ${targargs}"
846 fi
847
848 targargs="--host=${target_alias} ${targargs}"
849 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
850 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
851 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
852 Makefile > Makefile.tem
853 rm -f Makefile
854 mv -f Makefile.tem Makefile
855
856 #
857 # Local Variables:
858 # fill-column: 131
859 # End:
860 #
This page took 0.050496 seconds and 4 git commands to generate.